{$pbe ignore}
unit DefScript;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TPSForm = class(TForm)
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PSForm: TPSForm;

implementation

{$R *.dfm}

{$end pbe ignore}


procedure sbFBodyFileClick(Sender:TObject);
var
  s:string;
begin
  s:=trim(edFBodyFile.Text);   
  if SelectFile(s,'Textov soubory (*.txt)|*.txt|Html soubory (*.htm, *.html)|*.htm;*.html|Vechny soubory (*.*)|*.*') then      
    edFBodyFile.Text:=s;  
end;

procedure sbFAttachClick(Sender:TObject);
var
  s:string;
begin
  case mFAttachments.Lines.Count of
    0:s:='';
    1:s:=trim(mFAttachments.Lines.Text);  
  else  
    s:=mFAttachments.Lines[mFAttachments.Lines.Count-1]
  end;      

  // mFileMask.Hint contains the defined file extension filters
  if SelectFile(s,mFileMask.Hint) then    
  begin  
    if mFAttachments.SelText<>'' then
      mFAttachments.SelText:=s    
    else
      mFAttachments.Lines.Add(s);  
  end;
end;

procedure sbFStartFolderClick(Sender:TObject);
var
  s:string;  
  p:TPoint;
begin
  s:=FStartFolder.text;    
  p.x:=0; p.y:=sbFStartFolder.Height;
  p:=sbFStartFolder.ClientToScreen(p);
  if BrowseForFolder(sbFStartFolder.Hint,s,s,p) then  
    FStartFolder.Text:=s;
end;

procedure ParseCmdLineParams;
var
  i,c:integer;  
  prm,cl:string;
  key:string;
begin  
  mFBody.Lines.Text:='';
  cbFStartTLS.Checked:=False;
  cbFVerbose.Checked:=False;
  cbFAuth.ItemIndex:=0;
  cbFEHLO.Checked:=False;
  cbFQuiet.Checked:=False;
    
  cl:='dummy.exe '+ReplaceStr(FCmdLineParams.Text,'/C ""','/C "');
  if cl[length(cl)]='"' then
    delete(cl,length(cl),1);
  c:=MyCmdLineParamCount(cl);  
  for i:=3 To c do // skip /C "%ACTIONLIBRARY%\mailsend\mailsend.exe"
  begin
    prm:=MyCmdLineParamStr(cl,i);

    if length(key)>0 then
    begin
      if key='-smtp' then edFSMTP.Text:=prm
      else if key='-port' then edFPort.Text:=prm
      else if key='-f' then edFFrom.Text:=prm
      else if key='-name' then edFFromName.Text:=prm
      else if key='-t' then edFTo.Text:=prm
      else if key='-cc' then edFCopyTo.Text:=prm
      else if key='-sub' then edFSubject.Text:=prm
      else if key='-user' then edFUser.Text:=prm
      else if key='-pass' then edFPass.Text:=prm      
      else if key='-cs' then edFCharSet.Text:=prm
      else if key='-M' then mFBody.Lines.Text:=prm
      else if key='-attach' then 
      begin
        if pos('%FILE%',uppercase(prm))=0 then
          mFAttachments.Lines.Add(prm)
      end
      else if (key='-d') or (key='-bc') or (key='-l') or (key='-from') or (key='-rt') or (key='-rrr') then key:=''; // not supported yet      
      key:='';
    end

    else
    if prm='-starttls' then cbFStartTLS.Checked:=true
    else if prm='-v' then cbFVerbose.Checked:=true
    else if prm='-auth' then cbFAuth.ItemIndex:=4 // Automatic
    else if prm='-auth-cram-md5' then cbFAuth.ItemIndex:=3 // CRAM-MD5
    else if prm='-auth-login' then cbFAuth.ItemIndex:=2 // Login
    else if prm='-auth-plain' then cbFAuth.ItemIndex:=1 // Plain  
    else if prm='-ehlo' then cbFEHLO.Checked:=true
    else if prm='-q' then cbFQuiet.Checked:=true
  
    else
    if (prm='+cc') or (prm='+bc') or (prm='+D') or (prm='-V') or (prm='-w') 
      or (prm='-example') or (prm='-info') or (prm='-help') or (prm='<') then key:='' // fixed or not supported params  
    else
      key:=prm;
        
  end;
end;

procedure UpdateCmdLineParams(Sender:TObject);
var
  tmp,bf:string;
  i:integer;
begin
  tmp:='/C ""%ACTIONLIBRARY%\mailsend\mailsend.exe" +cc +bc'; // fixed params
    
  if length(edFFrom.Text)>0 then tmp:=tmp+' -f '+edFFrom.Text;
  if length(edFFromName.Text)>0 then tmp:=tmp+' -name "'+edFFromName.Text+'"';
  if length(edFTo.Text)>0 then tmp:=tmp+' -t "'+ReplaceStr(edFTo.Text,';',',')+'"';
  if length(edFCopyTo.Text)>0 then tmp:=tmp+' -cc "'+ReplaceStr(edFCopyTo.Text,';',',')+'"';
  if length(edFSubject.Text)>0 then tmp:=tmp+' -sub "'+edFSubject.Text+'"';
  
  for i:=1 to mFAttachments.Lines.Count-1 do // skip first
  begin
    bf:=trim(mFAttachments.Lines[i]);
    if length(bf)>0 then
      tmp:=tmp+' -attach "'+bf+'"';
  end;
  
  if length(edFSMTP.Text)>0 then tmp:=tmp+' -smtp '+edFSMTP.Text;
  if length(edFPort.Text)>0 then tmp:=tmp+' -port '+edFPort.Text;
  case cbFAuth.ItemIndex of
    1:tmp:=tmp+' -auth-plain';
    2:tmp:=tmp+' -auth-login';
    3:tmp:=tmp+' -auth-cram-md5';
    4:tmp:=tmp+' -auth';
  end;
  if length(edFUser.Text)>0 then tmp:=tmp+' -user "'+edFUser.Text+'"';
  if length(edFPass.Text)>0 then tmp:=tmp+' -pass "'+edFPass.Text+'"';
  if length(edFCharSet.Text)>0 then tmp:=tmp+' -cs "'+edFCharSet.Text+'"';
  if cbFStartTLS.Checked then tmp:=tmp+' -starttls';
  if cbFEHLO.Checked then tmp:=tmp+' -ehlo';
  if cbFVerbose.Checked then tmp:=tmp+' -v';
  if cbFQuiet.Checked then tmp:=tmp+' -q';
  
  for i:=mFBody.Lines.Count-1 downto 0 do
    if length(trim(mFBody.Lines[i]))=0 then
      mFBody.Lines.Delete(i)
    else
      break;         
  if trim(mFBody.Lines.Text)<>'' then
    tmp:=tmp+' -M "'+ReplaceStr(mFBody.Lines.Text,#13#10,' ')+'"';

  if length(trim(edFBodyFile.Text))>0 then
    tmp:=tmp+' <%FILE%';
  tmp:=tmp+'"';

  FCmdLineParams.Text:=tmp;
end;  

procedure SaveSettings;
begin
  UpdateCmdLineParams(nil);  

  mFileMask.Lines.Text:=edFBodyFile.Text;
  edParams.Text:=FCmdLineParams.Text;
  edStartFolder.Text:=FStartFolder.Text;
  cbHideWindow.Checked:=FHideWindow.Checked;
  cbWaitFor.Checked:=FWaitFor.Checked;
  cbDontExpandMask.Checked:=True;
  cbVar.Text:=FOutputVar.Text;
end;

{---------- LoadSettings: Required method! ------------------------------------- 
  Here you can transform the Precision Builder Express command-line interface  
  fields into the values of your GUI. See the description of fields above.     
-------------------------------------------------------------------------------}
procedure LoadSettings;
begin
  edFPass.PasswordChar:='*';
  if mFileMask.Lines.Count>0 then
    edFBodyFile.Text:=trim(mFileMask.Lines[0])
  else
    edFBodyFile.Text:='';
  FCmdLineParams.Text:=edParams.Text;
  FStartFolder.Text:=edStartFolder.Text;
  FHideWindow.Checked:=cbHideWindow.Checked;
  FWaitFor.Checked:=cbWaitFor.Checked;
  mFAttachments.Hint:=mFAttachments.Hint+'|'+mFileMask.Hint;
  if cbVar.Parent=tsCommandLine then
  begin
    FOutputVar.Items.Text:=cbVar.Items.Text;
    FOutputVar.Text:=cbVar.Text;
  end
  else  
  begin
    FOutputVar.Visible:=False;
    lbFOutputVar.Visible:=False;    
  end;  

  sbFStartFolder.OnClick:=@sbFStartFolderClick;  
end;

{---------- Main script body ---------------------------------------------------
  Calling the LoadSettings method is required!      
-------------------------------------------------------------------------------}
begin
  LoadSettings;
  ParseCmdLineParams;   
  sbFAttach.OnClick:=@sbFAttachClick;
  sbFBodyFile.OnClick:=@sbFBodyFileClick;    
end.